/* FONTINST.CMD fr Kompatibilittsschriftarten */

x = setlocal()

echo = '@'

i = 1
typ.i = CODEDFONTS;    typreq.i = NO; i = i + 1
typ.i = COMPAT240;     typreq.i = NO; i = i + 1
typ.i = COMPAT300;     typreq.i = NO; i = i + 1
typ.i = ALL;           typreq.i = NO
tottypes = i

source = '.'

ARG commandline

if WORDS(commandline) <> 0 then do
  if WORDS(commandline) < 2 then do
    targetdrv = WORD(commandline, 1)
    fontset.1 = ALL
    totfont = 1
  end
  else do
    if WORDS(commandline) < 7 then do
      targetdrv = WORD(commandline, 1)
      do i = 2 to WORDS(commandline)
        if WORDS(commandline) >= i then do
          j = i - 1
          fontset.j = WORD(commandline, i)
        end
      end
      totfont = WORDS(commandline) - 1
    end
    else do
      CALL HELP;
    end
  end
end
else do
  CALL HELP;
end

if POS(':', targetdrv) <> 2 then do
  CALL HELP;
end
drvlet = SUBSTR(targetdrv, 1, 1)
if POS(drvlet, 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz') = 0 then do
  CALL HELP;
end
if LENGTH(targetdrv) <> 2 then do
  CALL HELP;
end

targetdir = targetdrv || '\PSF2RES'

say '*********************************************************'
say '* Fr die PSF/2-Schriftarten mu ausreichend Platz auf'
say '* der Festplatte vorhanden sein. Die <Eingabetaste>'
say '* drcken, um die Installation der PSF/2-Schriftart-'
say '* optionen fortzusetzen, oder <Strg+C> drcken, um sie'
say '* zu stoppen. Nach Beginn der Installation mu diese'
say '* Tastenkombination eventuell mehrmals gedrckt werden,'
say '* bis die Installation gestoppt wird.'
say '*********************************************************'
parse upper pull dummy

echo || 'md 'targetdir

if rc <> 0 then do
  call RxFuncAdd 'SysMkDir', 'RexxUtil', 'SysMkDir'
  ret_code = SysMkDir(targetdir)
  if ret_code <> 5 then do
    EXIT;
  end
end

do i = 1 to totfont
  matchfound = NO
  do j = 1 by 1 while SYMBOL('typ.j') = 'VAR'
    if fontset.i = typ.j then do
      matchfound = YES
      typreq.j = YES
      leave
    end
  end
  if matchfound = NO then do
    CALL HELP;
  end
end

say '*********************************************************'
say '* Die Schriftartdateien von PSF/2 2.00 aus dem'
say '* aktuellen Verzeichnis in das Verzeichnis 'targetdir''
say '* stellen. Gibt es ein Verzeichnis bereits, ohne da die'
say '* Dateien vorhanden sind, werden Fehlernachrichten'
say '* angezeigt. Diese Nachrichten ignorieren. <Strg+C>'
say '* drcken, um die Verarbeitung zu stoppen. Eventuell mu'
say '* diese Tastenkombination mehrmals gedrckt werden, bis'
say '* die Installation gestoppt wird.'
say '*********************************************************'

echo || 'md 'targetdir'\FONTC240'
echo || 'md 'targetdir'\FONTC300'
echo || 'md 'targetdir'\CODEFONT'
echo || 'md 'targetdir'\CODEPAGE'
echo || 'md 'targetdir'\CODEPAGE\PRIMARY'
echo || 'md 'targetdir'\CODEPAGE\SECONDRY'

echo || 'attrib -r 'targetdir'\*.* /s'
if rc <> 0 then do
  if rc <> 2 then do
    EXIT;
  end
end

font240d = NO
font300d = NO
codefontd = NO
codepaged = NO
do i = 1 to tottypes
  if typreq.i = YES then do
    select
      when typ.i = CODEDFONTS then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        codefontd = YES
      end
      when typ.i = COMPAT240 then do
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        codepaged = YES
      end
      when typ.i = COMPAT300 then do
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font300d = YES
        codepaged = YES
      end
      when typ.i = ALL then do
        echo || '.\loadram2 'source'\COMPCF.FLS 'targetdir'\CODEFONT\ /D'
        echo || '.\loadram2 'source'\COMPC240.FLS 'targetdir'\FONTC240\ /D'
        echo || '.\loadram2 'source'\COMPC300.FLS 'targetdir'\FONTC300\ /D'
        echo || '.\loadram2 'source'\PRIMARY.FLS 'targetdir'\CODEPAGE\PRIMARY\ /D'
        echo || '.\loadram2 'source'\SECONDRY.FLS 'targetdir'\CODEPAGE\SECONDRY\ /D'
        font240d = YES
        font300d = YES
        codefontd = YES
        codepaged = YES
      end
      otherwise
        say 'Bei diesem Programm ist ein Fehler aufgetreten.'
        say 'Den PSF/2-Verantwortlichen verstndigen.'
    end
  end
end

targetdrv
echo || 'cd 'targetdir

say '*********************************************************'
say '* Die Schriftarten von PSF/2 2.00 der Ressourcen-'
say '* verwaltung hinzufgen. Zum Stoppen <Strg+C> drcken.'
say '*********************************************************'

if font240d = YES then do
  echo || 'cd .\FONTC240'
  echo || 'RLADD R *.* * /R /L > ..\FONT240.LOG'
  echo || 'cd ..'
end

if font300d = YES then do
  echo || 'cd .\FONTC300'
  echo || 'RLADD R *.* * /R /L > ..\FONT300.LOG'
  echo || 'cd ..'
end

if codefontd = YES then do
  echo || 'cd .\CODEFONT'
  echo || 'RLADD R *.* * /R /L > ..\FONTCF.LOG'
  echo || 'cd ..'
end

if codepaged = YES then do
  echo || 'cd .\CODEPAGE\PRIMARY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTPRI.LOG'
  echo || 'cd ..\SECONDRY'
  echo || 'RLADD R *.* * /R /L > ..\..\FONTSEC.LOG'
  echo || 'cd ..\..'
end

say '*********************************************************'
say '* Schriftarten wurden hinzugefgt. Einzelheiten'
say '* der Datei 'targetdir'\FONT*.LOG entnehmen.'
say '*********************************************************'

x = endlocal()
CALL QUIT;

HELP:;
  say '**************************************************************';
  say '* Dieser Installationsbefehl mu in dem Verzeichnis          *';
  say '* ausgefhrt werden, in dem sich die PSF/2-Installations-    *';
  say '* dateien befinden.                                          *';
  say '*                                                            *';
  say '* Fr diesen Befehl ist ein Parameter erforderlich.          *';
  say '*                                                            *';
  say '* Das Format lautet:                                         *';
  say '*   FONTINST <ziellaufwerk> <schriftarten>                   *';
  say '*                                                            *';
  say '* Dabei ist:                                                 *';
  say '*   <ziellaufwerk> das Laufwerk, auf dem PSF/2 installiert   *';
  say '*     ist. Dies ist NICHT das Laufwerk, auf dem die PSF/2-   *';
  say '*     Dateien mit dem Befehl PUTDIR temporr gesichert       *';
  say '*     wurden. Dieser Parameter ist erforderlich.             *';
  say '*   <schriftarten> einer der folgenden Werte:                *';
  say '*     ALL (Standardwert)                                     *';
  say '*     CODEDFONTS                                             *';
  say '*     COMPAT240                                              *';
  say '*     COMPAT300                                              *';
  say '* Beispiel:                                                  *';
  say '*   fontinst c: all                                          *';
  say '*                                                            *';
  say '* Schriftarten werden im Verzeichnis \PSF2RES installiert.   *';
  say '* Weitere in den Schriftartverzeichnissen enthaltenen        *';
  say '* Schriftarten werden der Ressourcenverwaltung hinzugefgt.  *';
  say '**************************************************************';
  x = endlocal()
  CALL QUIT;
RETURN;

QUIT:;
EXIT;
